; $Id: launch_nsefilelist.pro,v 1.1 2007/03/27 15:51:21 kneller Exp $
;###############################################################################
;
;NAME:
;        launch_NSEFileList
;
;PURPOSE:
;
;PARAMETERS:
;
;KEYWORDS:
;
;_EXTRA - is used to pass keywords meant for the superclass.
;
;###############################################################################
pro launch_NSEFileList,event


    if ptr_valid(!dave_defaults) gt 0 then begin
        work_dir = (*!dave_defaults).workDir
        data_dir = (*!dave_defaults).datDir
    endif else begin
        work_dir = '.'
        data_dir = '.'
    endelse

    nseFileList,group_leader = event.top,data_dir = data_dir,work_dir=work_dir,$
                startdir = data_dir,notify_ids=[event.id,event.top]

;    ;SET UP THIS LAUNCH METHOD SO IT BEHAVES SAME AS launchNse WITH THE SAME ARGUMENTS SO THAT
;    ;THEY WILL BE AVAILABLE TO PASS TO launchNSE if an ooDisplayEcho data object is not available.
;
;    this_event = tag_names(event,/structure_name)
;    print,this_event
;    case this_event of
;    'WIDGET_BUTTON':begin
;        work_dir = (*!dave_defaults).workDir
;        data_dir = (*!dave_defaults).datDir
;        device,decomposed = 0
;        onse = obj_new('ooDisplayEcho',notify_ids = [event.id,event.top], $
;            group_leader = event.top,work_dir = work_dir,data_dir = data_dir,dave_id=event.top)
;    end
;    'WIDGET_TREE_SEL':begin
;        device,decomposed = 0
;        work_dir = (*!dave_defaults).workDir
;        data_dir = (*!dave_defaults).datDir
;        onse = obj_new('ooDisplayEcho',notify_ids = [event.id,event.top], $
;            group_leader = event.top,work_dir = work_dir, data_dir = data_dir,dave_id=event.top)
;    end
;    'NSE_EVENT':begin
;        widget_control,event.top,/show,/input_focus,iconify = 0
;    end
;    else:
;    endcase
end;launchNSEFileList

